/***************************************************************************/
/* User errorhandling routine					           */
/*                                                                         */
/* Version: 1.A.    Stand: 26.04.1995	                                   */
/*                                                                         */
/***************************************************************************/

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <ml6bib.h>

void far pascal error_handler(void);

/* User errorhandler */

void far pascal error_handler(void)
{
	struct ml6_error_info_type  error_info, *err_p=&error_info;
	int	i;
	char	s80[81];
	char	ch;
	ushort	w;


	ml6_get_error_info(err_p);

	if (err_p->mark==0) return;
	if (err_p->errorclass == 6) return;	/* call_func - Errorcode */

	printf("\n\n\nBenutzer-eigene Fehlerbehandlung\n\n");

	if (err_p->errorclass==5)
	{
	  w=ml6_get_message();

	  printf("Die Fehlermeldung wurde durch einen Errorrequest\n");
	  printf("von der MODULAR-4 Karte ausgelst\n\n");
	  printf("Fehler-Request von Karte: ");
	  printf("     SRQ: %X>H\n",w);
	  printf("Bitte eine Taste drcken ");

	  while (!kbhit()) ;
	  return;
	}
	printf("\n");
	if (err_p->statusmap & 128 > 0)
	{
	  printf("Kommunikationsversuch ohne Initialisierung der \n");
	  printf("Bibliothek fr die angewhlte Karte\n");
	  printf("Verwenden Sie ml6_start oder ml6_reset\n");
	  printf("Programm angehalten\n");
	  abort();
	}
	if (err_p->statusmap & 1 > 0)
	{
	  printf("Kommunikationsversuch ohne ausreichende Fehlerbehandlung.\n");
	  printf("Verwenden Sie ml6_clear_error in der Fehlerbehandlungsroutine\n");
	  printf("Die Fehlervariablen enthalten noch den ursprnglichen Fehler.\n\n");
	}
	ml6_get_error_message(s80);
	printf("Fehlernachricht: %s\n",s80);
	printf("Fehlerklasse %d     ",err_p->errorclass);
	printf("Fehler-Code %d\n",err_p->errorcode);
	printf("Fehler aufgetreten bei Ausfhrung von Makro-Befehl %XH\n",err_p->outwords[0]);
	printf("Schnittstellenstatus (Basisadresse) %XH\n",err_p->statusport);

	printf("\nFehler aufgetreten nach Markierung %d\n",err_p->mark);
	ml6_get_mark_message(s80);
	printf("Mark-Nachricht: %s\n",s80);

	printf("\nProgramm weiterfhren <RETURN> oder Abbruch <A/a> ? ");

	ch='x';
	while (strchr("Aa'\r'", ch)==0) ch=getch();
	if (strchr("Aa", ch)>0)
	{
		printf("\nProgramm wird angehalten\n");
		ml6_exit();
		abort();
	}
	else
	{
		printf("\nProgramm wird weitergefhrt\n");
		ml6_clear_error();
		ml6_get_error_message(s80);
		if (strcmp(s80, "")!=0)
		{	printf("ml6_clear_error() lscht die error_message nicht\n");
		}
		w=ml6_clear();
		if (w>0)
		{
		printf("\nml6_clear ist erfolglos. Programm wird angehalten\n");
		ml6_exit();
		abort();
		}
	}
}

